/**
 * OpenGL RedBook Shader.
 * Example 7.8
 */
#version 330 core


layout (location = 0) in vec3 VertexPosition;
layout (location = 1) in vec3 VertexNormal;
layout (location = 2) in vec3 VertexColour;
layout (location = 3) in vec2 VertexTex;

uniform mat4 MVPMatrix;
uniform mat4 MVMatrix;
uniform mat3 NormalMatrix;

out Vertex {
    vec3 Position;
    vec3 Normal;
    vec3 Colour;
    vec2 TexPos;
};

void main() {
    Colour = VertexColour;
    Normal = mat3(transpose(inverse(MVMatrix))) * VertexNormal;
    TexPos = VertexTex;
    Position = vec3(MVMatrix * vec4(VertexPosition, 1));

    gl_Position = MVPMatrix * vec4(VertexPosition, 1);
}